
local Find = Object.GetNearbyObjects
local timeTot = 0

function Create()
end

function Update(timePassed)
	if timePerUpdate == nil then
		if this.DoorID == nil then return end
		for thatDoor in next, Find(this,this.DoorType,2) do
			if thatDoor.Id.i == this.DoorID then MyDoor = thatDoor end
		end
		this.SubType = this.Sub
		this.Tooltip = "\nMonitoring "..this.DoorType.."\nDoor ID: "..this.DoorID.."\n\nPosX: "..this.PosX.."  PosY: "..this.PosY.."\nOrX: "..this.OrX.."  OrY: "..this.OrY.."\nDirX: "..MyDoor.OpenDir.x.."  DirY: "..MyDoor.OpenDir.y.."\n\n - Mode: "..MyDoor.Mode.."\n - Changing: "..MyDoor.Changing.."\n - Open: "..MyDoor.Open.."\n - CloseTimer: "..MyDoor.CloseTimer
		timePerUpdate = 0.1
	else
		timeTot = timeTot + timePassed
		if timeTot >= timePerUpdate then
			timeTot = 0
			if Exists(MyDoor) then
				if MyDoor.CarrierId.i > -1 then									-- door got carried away
					FixDoor(true)
				elseif MyDoor.Changing == 1 then								-- door is opening, fix orientation bug and set Green light
					MyDoor.Or.x,MyDoor.Or.y,this.SubType = this.OrX,this.OrY,this.Sub + 4
					this.Tooltip = "\nMonitoring "..this.DoorType.."\nDoor ID: "..this.DoorID.."\n\nPosX: "..this.PosX.."  PosY: "..this.PosY.."\nOrX: "..this.OrX.."  OrY: "..this.OrY.."\nDirX: "..MyDoor.OpenDir.x.."  DirY: "..MyDoor.OpenDir.y.."\n\n - Mode: "..MyDoor.Mode.."\n - Changing: "..MyDoor.Changing.."\n - Open: "..MyDoor.Open.."\n - CloseTimer: "..MyDoor.CloseTimer
				elseif MyDoor.Changing == -1 then								-- door is closing, set Red light
					this.SubType,closing = this.Sub,true
					this.Tooltip = "\nMonitoring "..this.DoorType.."\nDoor ID: "..this.DoorID.."\n\nPosX: "..this.PosX.."  PosY: "..this.PosY.."\nOrX: "..this.OrX.."  OrY: "..this.OrY.."\nDirX: "..MyDoor.OpenDir.x.."  DirY: "..MyDoor.OpenDir.y.."\n\n - Mode: "..MyDoor.Mode.."\n - Changing: "..MyDoor.Changing.."\n - Open: "..MyDoor.Open.."\n - CloseTimer: "..MyDoor.CloseTimer
				elseif MyDoor.Changing == 0 and closing then FixDoor() end		-- door is closed, spawn fresh door to fix another bug
			else
				this.Delete()
			end
		end
	end
end

function FixDoor(opening)
	MyDoor.Delete()
	MyDoor = nil
	
	local newDoor = Object.Spawn(this.DoorType,this.PosX,this.PosY)
	newDoor.Or.x = this.OrX
	newDoor.Or.y = this.OrY
	newDoor.OpenDir.x = this.DirX 
	newDoor.OpenDir.y = this.DirY
	if opening then newDoor.Open = 0.1 else newDoor.Open,newDoor.Changing = 0,0 end
	this.DoorID = newDoor.Id.i
	
	MyDoor = newDoor
	closing = nil
	this.Tooltip = "\nMonitoring "..this.DoorType.."\nDoor ID: "..this.DoorID.."\n\nPosX: "..this.PosX.."  PosY: "..this.PosY.."\nOrX: "..this.OrX.."  OrY: "..this.OrY.."\nDirX: "..MyDoor.OpenDir.x.."  DirY: "..MyDoor.OpenDir.y.."\n\n - Mode: "..MyDoor.Mode.."\n - Changing: "..MyDoor.Changing.."\n - Open: "..MyDoor.Open.."\n - CloseTimer: "..MyDoor.CloseTimer
end

function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end
