
local Find = Object.GetNearbyObjects
local timeTot = 0
local DoorTypes = { "JailDoorLarge","JailDoorLargeGrey","JailDoorLargeOrange","JailDoorLargeRed","JailDoorLargeWhite","JailDoorLargeYellow" }
local X = 0
local Y = 0
local OrX = 0
local OrY = 0
local PosX = 0
local PosY = 0
local Sub = 0

function Create()
	local found = false
	for _, typ in pairs(DoorTypes) do
		local nearbyObject = Find(typ,3)
		for thatDoor, _ in pairs(nearbyObject) do
			FindExistingDoorChecker(thatDoor)
			if not CheckerFound then
				-- attempt to repair bugged door positions, might not always work fine though
				if thatDoor.OpenDir.y == -2		 then thatDoor.Pos.x,thatDoor.Pos.y,thatDoor.Or.x,thatDoor.Or.y = math.floor(thatDoor.Pos.x)+0.5,math.floor(thatDoor.Pos.y),-1,0
				elseif thatDoor.OpenDir.y == 2	 then thatDoor.Pos.x,thatDoor.Pos.y,thatDoor.Or.x,thatDoor.Or.y = math.floor(thatDoor.Pos.x)+0.5,math.floor(thatDoor.Pos.y),1,0
				elseif thatDoor.OpenDir.x == -2	 then thatDoor.Pos.x,thatDoor.Pos.y,thatDoor.Or.x,thatDoor.Or.y = math.floor(thatDoor.Pos.x),math.floor(thatDoor.Pos.y)+0.5,0,1
				elseif thatDoor.OpenDir.x == 2	 then thatDoor.Pos.x,thatDoor.Pos.y,thatDoor.Or.x,thatDoor.Or.y = math.floor(thatDoor.Pos.x),math.floor(thatDoor.Pos.y)+0.5,0,-1
				end
				-- init values
				OrX,OrY,PosX,PosY = thatDoor.Or.x,thatDoor.Or.y,thatDoor.Pos.x,thatDoor.Pos.y
				
				if OrX == 0 and OrY == 1 then		 Sub,X,Y = 0,math.floor(PosX)+1.5,math.floor(PosY)+0.5
				elseif OrX == 0 and OrY == -1 then	 Sub,X,Y = 1,math.floor(PosX)-1.5,math.floor(PosY)+0.5
				elseif OrX == 1 and OrY == 0 then	 Sub,X,Y = 2,math.floor(PosX)+0.5,math.floor(PosY)-1.5
				elseif OrX == -1 and OrY == 0 then	 Sub,X,Y = 3,math.floor(PosX)+0.5,math.floor(PosY)+1.5
				end
				
				MyDoor = thatDoor
				found = true
				break
			end
		end
		nearbyObject = nil
		if found == true then break end
	end
	if found == true then
		local newChecker = Object.Spawn("DoorChecker",X,Y)
		newChecker.SubType = Sub
		newChecker.Sub = Sub
		newChecker.DoorType = MyDoor.Type
		newChecker.DoorID = MyDoor.Id.i
		newChecker.DirX = MyDoor.OpenDir.x
		newChecker.DirY = MyDoor.OpenDir.y
		newChecker.OrX = OrX
		newChecker.OrY = OrY
		newChecker.PosX = PosX
		newChecker.PosY = PosY
	end
	this.Delete()
end

function FindExistingDoorChecker(theDoor)
	CheckerFound = false
	for thatChecker in next, Find(theDoor,"DoorChecker",2) do
		if thatChecker.DoorID == theDoor.Id.i then
			CheckerFound = true
		end
	end
end
